## rt-tests 0.39

=== Makefile ===
VERSION_STRING = "0.39"

TARGETS	= cyclictest signaltest classic_pi pi_stress
FLAGS	= -Wall -Wno-nonnull -O2
LIBS 	= -lpthread -lrt
DESTDIR	?=
prefix  ?= /usr/local
bindir  ?= $(prefix)/bin
mandir	?= $(prefix)/share/man/man8

all: $(TARGETS)

cyclictest: src/cyclictest/cyclictest.c
	$(CC) $(FLAGS) -D VERSION_STRING=$(VERSION_STRING) $^ -o $@ $(LIBS)

signaltest: src/signaltest/signaltest.c
	$(CC) $(FLAGS) -D VERSION_STRING=$(VERSION_STRING) $^ -o $@ $(LIBS)

classic_pi: src/pi_tests/classic_pi.c
	$(CC) $(FLAGS) -D_GNU_SOURCE -D VERSION_STRING=\"$(VERSION_STRING)\" $^ -o $@ $(LIBS)

pi_stress:  src/pi_tests/pi_stress.c
	$(CC) $(FLAGS) -D_GNU_SOURCE -D VERSION_STRING=\"$(VERSION_STRING)\" $^ -o $@ $(LIBS)

CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec
CLEANUP += $(if $(wildcard .git), ChangeLog)

clean:
	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done

distclean: clean
	rm -rf BUILD RPMS SRPMS releases

changelog:
	git log >ChangeLog

install: all
	mkdir -p "$(DESTDIR)$(bindir)" "$(DESTDIR)$(mandir)"
	cp $(TARGETS) "$(DESTDIR)$(bindir)"
	gzip src/cyclictest/cyclictest.8 -c >"$(DESTDIR)$(mandir)/cyclictest.8.gz"
	gzip src/pi_tests/pi_stress.8 -c >"$(DESTDIR)$(mandir)/pi_stress.8.gz"

release: clean changelog
	mkdir -p releases
	rm -rf tmp && mkdir -p tmp/rt-tests
	cp -r Makefile COPYING ChangeLog src tmp/rt-tests
	tar -C tmp -czf rt-tests-$(VERSION_STRING).tar.gz rt-tests
	rm -f ChangeLog
	cp rt-tests-$(VERSION_STRING).tar.gz releases

rt-tests.spec: Makefile rt-tests.spec-in
	sed s/__VERSION__/$(VERSION_STRING)/ <$@-in >$@

HERE	:=	$(shell pwd)
RPMARGS	:=	--define "_topdir $(HERE)" 	\
		--define "_sourcedir $(HERE)/releases" 	\
		--define "_builddir $(HERE)/BUILD" 	\

rpm:	rpmdirs release rt-tests.spec
	rpmbuild -ba $(RPMARGS) rt-tests.spec

rpmdirs:
	@[ -d BUILD ]  || mkdir BUILD
	@[ -d RPMS ]   || mkdir RPMS
	@[ -d SRPMS ]  || mkdir SRPMS

## rt-tests 0.53

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
-VERSION_STRING = "0.39"
+VERSION_STRING = 0.53
 
-TARGETS	= cyclictest signaltest classic_pi pi_stress
+TARGETS	= cyclictest signaltest classic_pi pi_stress \
+	  hwlatdetect rt-migrate-test
 FLAGS	= -Wall -Wno-nonnull -O2
 LIBS 	= -lpthread -lrt
 DESTDIR	?=
@@ -22,14 +23,22 @@
 pi_stress:  src/pi_tests/pi_stress.c
 	$(CC) $(FLAGS) -D_GNU_SOURCE -D VERSION_STRING=\"$(VERSION_STRING)\" $^ -o $@ $(LIBS)
 
+hwlatdetect:  src/hwlatdetect/hwlatdetect.py
+	chmod +x src/hwlatdetect/hwlatdetect.py
+	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect
+
+rt-migrate-test: src/rt-migrate-test/rt-migrate-test.c
+	$(CC) $(FLAGS) -D_GNU_SOURCE -D VERSION_STRING=\"$(VERSION_STRING)\" $^ -o $@ $(LIBS)
+
 CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec
 CLEANUP += $(if $(wildcard .git), ChangeLog)
 
 clean:
 	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done
+	rm -f hwlatdetect
 
 distclean: clean
-	rm -rf BUILD RPMS SRPMS releases
+	rm -rf BUILD RPMS SRPMS releases *.tar.gz rt-tests.spec
 
 changelog:
 	git log >ChangeLog
@@ -39,6 +48,7 @@
 	cp $(TARGETS) "$(DESTDIR)$(bindir)"
 	gzip src/cyclictest/cyclictest.8 -c >"$(DESTDIR)$(mandir)/cyclictest.8.gz"
 	gzip src/pi_tests/pi_stress.8 -c >"$(DESTDIR)$(mandir)/pi_stress.8.gz"
+	gzip src/hwlatdetect/hwlatdetect.8 -c >"$(DESTDIR)$(mandir)/hwlatdetect.8.gz"
 
 release: clean changelog
 	mkdir -p releases
@@ -47,6 +57,12 @@
 	tar -C tmp -czf rt-tests-$(VERSION_STRING).tar.gz rt-tests
 	rm -f ChangeLog
 	cp rt-tests-$(VERSION_STRING).tar.gz releases
+
+push:	release
+	scripts/do-git-push $(VERSION_STRING)
+
+pushtest: release
+	scripts/do-git-push --test $(VERSION_STRING)
 
 rt-tests.spec: Makefile rt-tests.spec-in
 	sed s/__VERSION__/$(VERSION_STRING)/ <$@-in >$@
@@ -63,3 +79,15 @@
 	@[ -d BUILD ]  || mkdir BUILD
 	@[ -d RPMS ]   || mkdir RPMS
 	@[ -d SRPMS ]  || mkdir SRPMS
+
+help:
+	@echo ""
+	@echo " rt-tests useful Makefile targets:"
+	@echo ""
+	@echo "    all       :  build all tests (default"
+	@echo "    install   :  install tests to local filesystem"
+	@echo "    release   :  build source tarfile"
+	@echo "    rpm       :  build RPM package"
+	@echo "    clean     :  remove object files"
+	@echo "    distclean :  remove all generated files"
+	@echo "    help      :  print this message"

## rt-tests 0.71

=== Makefile ===
VERSION_STRING = 0.71

sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\
	  pip_stress.c hackbench.c

TARGETS = $(sources:.c=)

LIBS 	= -lrt -lpthread
EXTRA_LIBS ?= -ldl	# for get_cpu
DESTDIR	?=
prefix  ?= /usr/local
bindir  ?= $(prefix)/bin
mandir	?= $(prefix)/share/man
srcdir	?= $(prefix)/src

CFLAGS = -D_GNU_SOURCE -Wall -Wno-nonnull -Isrc/include

PYLIB  := $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')

ifndef DEBUG
	CFLAGS	+= -O2
else
	CFLAGS	+= -O0 -g
endif

ifdef NUMA
	CFLAGS += -DNUMA
	NUMA_LIBS = -lnuma
endif

VPATH	= src/cyclictest:
VPATH	+= src/signaltest:
VPATH	+= src/pi_tests:
VPATH	+= src/rt-migrate-test:
VPATH	+= src/ptsematest:
VPATH	+= src/sigwaittest:
VPATH	+= src/svsematest:
VPATH	+= src/pmqtest:
VPATH	+= src/backfire:
VPATH	+= src/lib
VPATH	+= src/hackbench

%.o: %.c
	$(CC) -D VERSION_STRING=$(VERSION_STRING) -c $< $(CFLAGS)

# Pattern rule to generate dependency files from .c files
%.d: %.c
	@$(CC) -MM $(CFLAGS) $< | sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' > $@ || rm -f $@

.PHONY: all
all: $(TARGETS) hwlatdetect

# Include dependency files, automatically generate them if needed.
-include $(sources:.c=.d)

cyclictest: cyclictest.o rt-utils.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(NUMA_LIBS)

signaltest: signaltest.o rt-utils.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

pi_stress: pi_stress.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

hwlatdetect:  src/hwlatdetect/hwlatdetect.py
	chmod +x src/hwlatdetect/hwlatdetect.py
	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect

rt-migrate-test: rt-migrate-test.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

ptsematest: ptsematest.o rt-utils.o rt-get_cpu.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)

sigwaittest: sigwaittest.o rt-utils.o rt-get_cpu.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)

svsematest: svsematest.o rt-utils.o rt-get_cpu.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)

pmqtest: pmqtest.o rt-utils.o rt-get_cpu.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)

sendme: sendme.o rt-utils.o rt-get_cpu.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)

pip_stress: pip_stress.o error.o rt-utils.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

hackbench: hackbench.o
	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)

CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec *.d
CLEANUP += $(if $(wildcard .git), ChangeLog)

.PHONY: clean
clean:
	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done
	rm -f hwlatdetect
	rm -f tags

.PHONY: distclean
distclean: clean
	rm -rf BUILD RPMS SRPMS releases *.tar.gz rt-tests.spec

.PHONY: changelog
changelog:
	git log >ChangeLog

.PHONY: install
install: all
	mkdir -p "$(DESTDIR)$(bindir)" "$(DESTDIR)$(mandir)/man4"
	mkdir -p "$(DESTDIR)$(srcdir)" "$(DESTDIR)$(mandir)/man8"
	cp $(TARGETS) "$(DESTDIR)$(bindir)"
	if test -n "$(PYLIB)" ; then \
		mkdir -p "$(DESTDIR)$(PYLIB)" ; \
		install -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
		ln -s $(PYLIB)/hwlatdetect.py "$(DESTDIR)$(bindir)/hwlatdetect" ; \
	fi
	mkdir -p "$(DESTDIR)$(srcdir)/backfire"
	install -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"
	gzip src/backfire/backfire.4 -c >"$(DESTDIR)$(mandir)/man4/backfire.4.gz"
	gzip src/cyclictest/cyclictest.8 -c >"$(DESTDIR)$(mandir)/man8/cyclictest.8.gz"
	gzip src/pi_tests/pi_stress.8 -c >"$(DESTDIR)$(mandir)/man8/pi_stress.8.gz"
	gzip src/hwlatdetect/hwlatdetect.8 -c >"$(DESTDIR)$(mandir)/man8/hwlatdetect.8.gz"
	gzip src/ptsematest/ptsematest.8 -c >"$(DESTDIR)$(mandir)/man8/ptsematest.8.gz"
	gzip src/sigwaittest/sigwaittest.8 -c >"$(DESTDIR)$(mandir)/man8/sigwaittest.8.gz"
	gzip src/svsematest/svsematest.8 -c >"$(DESTDIR)$(mandir)/man8/svsematest.8.gz"
	gzip src/pmqtest/pmqtest.8 -c >"$(DESTDIR)$(mandir)/man8/pmqtest.8.gz"
	gzip src/backfire/sendme.8 -c >"$(DESTDIR)$(mandir)/man8/sendme.8.gz"
	gzip src/hackbench/hackbench.8 -c >"$(DESTDIR)$(mandir)/man8/hackbench.8.gz"

.PHONY: release
release: clean changelog
	mkdir -p releases
	rm -rf tmp && mkdir -p tmp/rt-tests
	cp -r Makefile COPYING ChangeLog src tmp/rt-tests
	tar -C tmp -czf rt-tests-$(VERSION_STRING).tar.gz rt-tests
	rm -f ChangeLog
	cp rt-tests-$(VERSION_STRING).tar.gz releases

.PHONY: push
push:	release
	scripts/do-git-push $(VERSION_STRING)

.PHONY: pushtest
pushtest: release
	scripts/do-git-push --test $(VERSION_STRING)

rt-tests.spec: Makefile rt-tests.spec-in
	sed s/__VERSION__/$(VERSION_STRING)/ <$@-in >$@

HERE	:=	$(shell pwd)
RPMARGS	:=	--define "_topdir $(HERE)" 	\
		--define "_sourcedir $(HERE)/releases" 	\
		--define "_builddir $(HERE)/BUILD" 	\

.PHONY: rpm
rpm:	rpmdirs release rt-tests.spec
	rpmbuild -ba $(RPMARGS) rt-tests.spec

.PHONY: rpmdirs
rpmdirs:
	@[ -d BUILD ]  || mkdir BUILD
	@[ -d RPMS ]   || mkdir RPMS
	@[ -d SRPMS ]  || mkdir SRPMS

.PHONY: help
help:
	@echo ""
	@echo " rt-tests useful Makefile targets:"
	@echo ""
	@echo "    all       :  build all tests (default"
	@echo "    install   :  install tests to local filesystem"
	@echo "    release   :  build source tarfile"
	@echo "    rpm       :  build RPM package"
	@echo "    clean     :  remove object files"
	@echo "    distclean :  remove all generated files"
	@echo "    help      :  print this message"

.PHONY: tags
tags:
	ctags -R --extra=+f --c-kinds=+p *

=== debian/changelog ===
rt-tests (0.71-1) unstable; urgency=low

  * new upstream release
  * drop install_backfire_c_into_srcdir_backfire (applied upstream)
  * drop rename_pip_to_pip_stress (applied upstream)
  * refresh install_hwlatdetect_into_sbindir
  * add powerpcspe to architecture list
  * add backfire package with dkms support

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Wed, 02 Jun 2010 22:15:03 +0200

rt-tests (0.66-2) unstable; urgency=high

  * Urgency high due to rc bug fix
  * new patch: rename pip to pip_stress (Closes: #572104)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Mon, 01 Mar 2010 17:02:28 +0100

rt-tests (0.66-1) unstable; urgency=low

  * add sh4 to architecture list (Closes: #555554)
  * new upstream release
  * Standards-Version: 3.8.4 (no changes needed)
  * Switch to dpkg-source 3.0 (quilt) format
  * build with libnuma on platforms that have it
  * new patch: install hwlatdetect directly into $sbindir
  * new patch: install install backfire.c to $(srcdir)/backfire/

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Mon, 22 Feb 2010 15:35:03 +0100

rt-tests (0.53-1) unstable; urgency=low

  * new upstream release
  * only build on Linux archs but not hppa (see #534352)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Thu, 29 Oct 2009 21:23:10 +0100

rt-tests (0.51-1) unstable; urgency=low

  * reformat copyright and add authors and years of the copyright
  * new upstream release
  * Standards-Version: 3.8.3 (no changes needed)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Sat, 19 Sep 2009 16:29:10 +0200

rt-tests (0.50-1) unstable; urgency=low

  * new upstream release

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Mon, 20 Jul 2009 21:50:08 +0200

rt-tests (0.45-1) unstable; urgency=low

  * new upstream release
  * add dependency on python for hwlatdetect
  * Standards-Version: 3.8.2 (no changes needed)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Tue, 30 Jun 2009 10:19:04 +0200

rt-tests (0.39-2) unstable; urgency=low

  * add VCS URL to control
  * conflict with xenomai-runtime (Closes: #529783)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Mon, 11 May 2009 00:18:37 +0200

rt-tests (0.39-1) unstable; urgency=low

  * Initial release. (Closes: #521895)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Wed, 06 May 2009 21:22:28 +0200

=== debian/control ===
Source: rt-tests
Section: misc
Priority: extra
Maintainer: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
Standards-Version: 3.8.4
Build-Depends: debhelper (>= 7.4.15), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc], dkms (>= 2.1.0.0)
Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

Package: rt-tests
Architecture: alpha amd64 armel i386 ia64 mips mipsel powerpc powerpcspe s390 sh4 sparc
Depends: ${shlibs:Depends}, ${misc:Depends}, python,
 libnuma1 (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc]
Conflicts: xenomai-runtime
Recommends: backfire-dkms
Description: Test programs for rt kernels
 rt-tests contains a set of programs that test and measure various components
 of real-time kernel behavior, such as timer latency, signal latency and the
 functioning of priority-inheritance mutexes.
 Additionally it contains hackbench, a program to generate work for the
 scheduler.

Package: backfire-dkms
Architecture: all
Depends: ${misc:Depends},
Replaces: rt-tests (<= 0.66-2)
Description: kernel module for signal benchmarking (DKMS)
 backfire is a driver used by sendme(8) (contained in the rt-tests package) to
 benchmark kernel to userspace signal generation.

=== debian/rules ===
#!/usr/bin/make -f

export prefix=/usr

ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel powerpc))
export NUMA=1
endif

DH = dh --with dkms

build: build-stamp
install: build install-stamp

build-stamp install-stamp:
	$(DH) ${@:-stamp=}
	touch $@

binary-arch binary-indep: install
	$(DH) $@

binary: binary-arch binary-indep

clean:
	$(DH) $@

.PHONY: build clean install binary-indep binary-arch binary

=== debian/watch ===
version=3

http://www.kernel.org/pub/linux/kernel/people/clrkwllms/rt-tests/rt-tests-(.*)\.tar\.gz

## rt-tests 0.72

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION_STRING = 0.71
+VERSION_STRING = 0.72
 
 sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
 	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\

=== src/backfire/Makefile ===
obj-m := backfire.o

all:	modules modules_install
	@echo Done

modules:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules

modules_install:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) modules_install

clean:
	make -C /lib/modules/$(shell uname -r)/build M=$(PWD) clean
	@rm -f *.o Module.markers modules.order

=== debian/changelog ===
rt-tests (0.72-1) unstable; urgency=low

  * new upstream release
  * new patch kernvar_fix_possible_buffer_overflow
  * use Architecture: linux-any (Closes: #604691)
  * Standards-Version: 3.9.1 (no changes needed)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Sun, 20 Mar 2011 16:31:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: misc
 Priority: extra
 Maintainer: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Build-Depends: debhelper (>= 7.4.15), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git
 
 Package: rt-tests
-Architecture: alpha amd64 armel i386 ia64 mips mipsel powerpc powerpcspe s390 sh4 sparc
+Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, python,
  libnuma1 (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc]
 Conflicts: xenomai-runtime

## rt-tests 0.83

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION_STRING = 0.72
+VERSION_STRING = 0.83
 
 sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
 	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\
@@ -14,6 +14,12 @@
 mandir	?= $(prefix)/share/man
 srcdir	?= $(prefix)/src
 
+machinetype = $(shell uname -m | \
+    sed -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')
+ifneq ($(filter x86_64 i386 ia64 mips powerpc,$(machinetype)),)
+NUMA 	:= 1
+endif
+
 CFLAGS = -D_GNU_SOURCE -Wall -Wno-nonnull -Isrc/include
 
 PYLIB  := $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')
@@ -24,7 +30,7 @@
 	CFLAGS	+= -O0 -g
 endif
 
-ifdef NUMA
+ifeq ($(NUMA),1)
 	CFLAGS += -DNUMA
 	NUMA_LIBS = -lnuma
 endif
@@ -114,12 +120,11 @@
 	mkdir -p "$(DESTDIR)$(srcdir)" "$(DESTDIR)$(mandir)/man8"
 	cp $(TARGETS) "$(DESTDIR)$(bindir)"
 	if test -n "$(PYLIB)" ; then \
-		mkdir -p "$(DESTDIR)$(PYLIB)" ; \
-		install -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
+		install -D -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
 		ln -s $(PYLIB)/hwlatdetect.py "$(DESTDIR)$(bindir)/hwlatdetect" ; \
 	fi
-	mkdir -p "$(DESTDIR)$(srcdir)/backfire"
-	install -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"
+	install -D -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"
+	install -m 644 src/backfire/Makefile "$(DESTDIR)$(srcdir)/backfire/Makefile"
 	gzip src/backfire/backfire.4 -c >"$(DESTDIR)$(mandir)/man4/backfire.4.gz"
 	gzip src/cyclictest/cyclictest.8 -c >"$(DESTDIR)$(mandir)/man8/cyclictest.8.gz"
 	gzip src/pi_tests/pi_stress.8 -c >"$(DESTDIR)$(mandir)/man8/pi_stress.8.gz"

=== debian/changelog ===
rt-tests (0.83-1) unstable; urgency=low

  * new upstream release

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Fri, 02 Dec 2011 10:40:15 +0100

rt-tests (0.74-1) unstable; urgency=low

  * new upstream release
  * Fix dkms warning (Closes: LP: #681908). Patch by eraserix, thanks.
  * add build-{arch,indep} targets to debian/rules
  * new patch providing a man page for pip_stress to make lintian a bit
    happier.
  * provide sequence as first parameter to dh for debhelper compatitility
    level 8 and switch to level 8
  * Standards-Version: 3.9.2 (no changes needed)
  * new patch to fix wording for error message when setting the
    scheduling policy fails (Closes: #619938)
  * drop patch kernvar_fix_possible_buffer_overflow (applied upstream)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Fri, 26 Aug 2011 09:25:37 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: misc
 Priority: extra
 Maintainer: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
-Standards-Version: 3.9.1
-Build-Depends: debhelper (>= 7.4.15), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc], dkms (>= 2.1.0.0)
+Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 8.1.0), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

## rt-tests 0.84

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION_STRING = 0.83
+VERSION_STRING = 0.84
 
 sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
 	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\
@@ -6,7 +6,7 @@
 
 TARGETS = $(sources:.c=)
 
-LIBS 	= -lrt -lpthread
+LIBS 	= -lrt -lpthread -lrttest -L.
 EXTRA_LIBS ?= -ldl	# for get_cpu
 DESTDIR	?=
 prefix  ?= /usr/local
@@ -14,13 +14,14 @@
 mandir	?= $(prefix)/share/man
 srcdir	?= $(prefix)/src
 
-machinetype = $(shell uname -m | \
-    sed -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')
+machinetype = $(shell $(CC) -dumpmachine | \
+    sed -e 's/-.*//' -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')
 ifneq ($(filter x86_64 i386 ia64 mips powerpc,$(machinetype)),)
 NUMA 	:= 1
 endif
 
-CFLAGS = -D_GNU_SOURCE -Wall -Wno-nonnull -Isrc/include
+CFLAGS ?= -D_GNU_SOURCE -Wall -Wno-nonnull -Isrc/include
+LDFLAGS ?=
 
 PYLIB  := $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')
 
@@ -60,44 +61,47 @@
 # Include dependency files, automatically generate them if needed.
 -include $(sources:.c=.d)
 
-cyclictest: cyclictest.o rt-utils.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(NUMA_LIBS)
+cyclictest: cyclictest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(NUMA_LIBS)
 
-signaltest: signaltest.o rt-utils.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)
+signaltest: signaltest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 pi_stress: pi_stress.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 hwlatdetect:  src/hwlatdetect/hwlatdetect.py
 	chmod +x src/hwlatdetect/hwlatdetect.py
 	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect
 
 rt-migrate-test: rt-migrate-test.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
-ptsematest: ptsematest.o rt-utils.o rt-get_cpu.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+ptsematest: ptsematest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
 
-sigwaittest: sigwaittest.o rt-utils.o rt-get_cpu.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+sigwaittest: sigwaittest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
 
-svsematest: svsematest.o rt-utils.o rt-get_cpu.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+svsematest: svsematest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
 
-pmqtest: pmqtest.o rt-utils.o rt-get_cpu.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+pmqtest: pmqtest.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
 
-sendme: sendme.o rt-utils.o rt-get_cpu.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+sendme: sendme.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
 
-pip_stress: pip_stress.o error.o rt-utils.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)
+pip_stress: pip_stress.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
 hackbench: hackbench.o
-	$(CC) $(CFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
 
-CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec *.d
+librttest.a: rt-utils.o error.o rt-get_cpu.o
+	$(AR) rcs librttest.a rt-utils.o error.o rt-get_cpu.o
+
+CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec *.d *.a
 CLEANUP += $(if $(wildcard .git), ChangeLog)
 
 .PHONY: clean
@@ -121,6 +125,7 @@
 	cp $(TARGETS) "$(DESTDIR)$(bindir)"
 	if test -n "$(PYLIB)" ; then \
 		install -D -m 755 src/hwlatdetect/hwlatdetect.py $(DESTDIR)$(PYLIB)/hwlatdetect.py ; \
+		rm -f "$(DESTDIR)$(bindir)/hwlatdetect" ; \
 		ln -s $(PYLIB)/hwlatdetect.py "$(DESTDIR)$(bindir)/hwlatdetect" ; \
 	fi
 	install -D -m 644 src/backfire/backfire.c "$(DESTDIR)$(srcdir)/backfire/backfire.c"

=== debian/changelog ===
rt-tests (0.84-0ubuntu1) quantal; urgency=low

  * New upstream release (LP: #1039352)
  * Update to standards version 3.9.3
  * Porting copyright file to match the machine-readable debian/copyright file
    standard version 1.0
  * Refreshing debian/patches based on this release
  * debian/patches/adding-missing-manpages.patch:
    - Adding missing manpages for signaltest and rt-migrate-test

 -- Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>  Mon, 20 Aug 2012 19:08:04 -0300

## rt-tests 0.85

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION_STRING = 0.84
+VERSION_STRING = 0.85
 
 sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
 	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\
@@ -20,7 +20,8 @@
 NUMA 	:= 1
 endif
 
-CFLAGS ?= -D_GNU_SOURCE -Wall -Wno-nonnull -Isrc/include
+CFLAGS ?= -Wall -Wno-nonnull
+CPPFLAGS += -D_GNU_SOURCE -Isrc/include
 LDFLAGS ?=
 
 PYLIB  := $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')
@@ -49,11 +50,11 @@
 VPATH	+= src/hackbench
 
 %.o: %.c
-	$(CC) -D VERSION_STRING=$(VERSION_STRING) -c $< $(CFLAGS)
+	$(CC) -D VERSION_STRING=$(VERSION_STRING) -c $< $(CFLAGS) $(CPPFLAGS)
 
 # Pattern rule to generate dependency files from .c files
 %.d: %.c
-	@$(CC) -MM $(CFLAGS) $< | sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' > $@ || rm -f $@
+	@$(CC) -MM $(CFLAGS) $(CPPFLAGS) $< | sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' > $@ || rm -f $@
 
 .PHONY: all
 all: $(TARGETS) hwlatdetect

=== debian/changelog ===
rt-tests (0.85-1ubuntu1) saucy; urgency=low

  * Merge with debian, remaining changes:
   - Backport newer debian/patches/backfire-fix-build-failure-for-modern-kernels.patch
     from upstream maintainer's tree git://git.pengutronix.de/git/ukl/rt-tests.git
     This patch includes removals to references of <asm/system.h> which no
     longer exists nor is needed in the backfire driver.  Without this patch we
     experience a dkms package build failure upon installation.  We won't need
     to carry this change once we sync from 0.86-1 or newer.
  * debian/patches/adding-missing-manpages.patch:
    - Adding missing manpages for signaltest and rt-migrate-test

 -- Andy Whitcroft <apw@canonical.com>  Thu, 15 Aug 2013 18:06:34 +0100

rt-tests (0.85-1) unstable; urgency=low

  * new upstream release
  * Build-Depends += libnuma-dev for powerpcspe, ppc64 and x32
    (Closes: #711952)
  * Standards-Version: 3.9.4 (no changes needed)

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Tue, 16 Jul 2013 20:32:07 +0200

rt-tests (0.85-0ubuntu2) saucy; urgency=low

  * Backport newer debian/patches/backfire-fix-build-failure-for-modern-kernels.patch
    from upstream maintainer's tree git://git.pengutronix.de/git/ukl/rt-tests.git
    This patch includes removals to references of <asm/system.h> which no
    longer exists nor is needed in the backfire driver.  Without this patch we
    experience a dkms package build failure upon installation.  We won't need
    to carry this change once we sync from 0.86-1 or newer.

 -- Leann Ogasawara <leann.ogasawara@canonical.com>  Mon, 05 Aug 2013 10:30:59 +0100

rt-tests (0.85-0ubuntu1) raring-proposed; urgency=low

  * New upstream release.

 -- Howard Chan <smartboyhw@gmail.com>  Tue, 18 Dec 2012 17:47:35 +0800

rt-tests (0.84-2) unstable; urgency=medium

  * fix backfire kernel module for Linux v3.4-rc1 and later
  * backport  
    	dd6ae11 (hackbench: init child's struct before using it)
    to make hackbench work on armhf. (Closes: #711363)

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Thu, 06 Jun 2013 21:30:30 +0200

rt-tests (0.84-1) experimental; urgency=low

  * new upstream release
  * convert copyright file to machine-readable copyright format version 1.0
  * Standards-Version: 3.9.3 (no changes needed)

 -- Uwe Kleine-König <u.kleine-koenig@pengutronix.de>  Sun, 02 Sep 2012 23:57:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: rt-tests
 Section: misc
 Priority: extra
-Maintainer: Uwe Kleine-König <u.kleine-koenig@pengutronix.de>
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 8.1.0), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc], dkms (>= 2.1.0.0)
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Uwe Kleine-König <uwe@kleine-koenig.org>
+Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc powerpcspe ppc64 x32], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git
 
@@ -21,6 +22,7 @@
  scheduler.
 
 Package: backfire-dkms
+Section: kernel
 Architecture: all
 Depends: ${misc:Depends},
 Replaces: rt-tests (<= 0.66-2)

## rt-tests 0.87

=== src/hackbench/Makefile ===
hackbench: hackbench.c
	$(CC) $(CFLAGS) -o hackbench hackbench.c -g -Wall -O2 -lpthread

clean :
	rm -f hackbench

=== src/pi_tests/Makefile ===
PACKAGE	:=	pi_tests
SPEC	:=	$(PACKAGE).spec
VERSION	:=	$(shell awk '/^Version:/ { print $$2 }' $(SPEC))
RELEASE	:=	$(shell awk '/Release:/ { print $$2 }' ${PACKAGE}.spec)
SRPM	:=	$(PACKAGE)-$(VERSION)-$(RELEASE).src.rpm
HERE	:= 	$(shell pwd)
TARGET	:=	$(shell uname -p)
RPMARGS	:=	--define "_sourcedir $(HERE)" 	\
		--define "_builddir $(HERE)/BUILD"	\
		--define "_rpmdir $(HERE)/RPMS" 	\
		--define "_srcrpmdir $(HERE)/SRPMS"
CC	:= gcc
OPT	:= -g -O
CFLAGS 	:= $(OPT) -Wall -D_GNU_SOURCE -DVERSION=\"$(VERSION)\"
LIBS	:= -lpthread -lrt

SRC	:= classic_pi.c allprios.c tst-mutexpi10.c pi_stress.c sigtest.c
DOC	:= pi_stress.8 README COPYING
TARGETS	:= $(subst .c,,$(SRC))

all: classic_pi pi_stress

classic_pi: classic_pi.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

pi_stress: pi_stress.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

tst-mutexpi10:  tst-mutexpi10.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

#tst-mutexpi10.c:	classic_pi.c
#	indent --gnu-style classic_pi.c -o tst-mutexpi10.c

allprios:	allprios.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

tarball:  pi_tests-$(VERSION).tar.gz

libctest: tst-mutexpi10

sigtest: sigtest.c
	$(CC) $(CFLAGS) -o $@ $< $(LIBS)

pi_tests-$(VERSION).tar.gz:	clean $(SRC) $(DOC) Makefile pi_tests.spec
	rm -rf $@ pi_tests-$(VERSION)
	mkdir pi_tests-$(VERSION)
	cp $(SRC) $(DOC) Makefile pi_tests.spec pi_tests-$(VERSION)
	tar -czvf pi_tests-$(VERSION).tar.gz pi_tests-$(VERSION)

clean:
	rm -rf *~ *.[oi] $(TARGETS) *.tar.gz pi_tests-*

rpm:  rpmdirs $(SPEC) tarball
	rm -rf RPMS/$(TARGET)
	rpmbuild -ba --target $(TARGET) $(RPMARGS) $(SPEC)

rpmdirs:
	@[ -d BUILD ]  || mkdir BUILD
	@[ -d RPMS ]   || mkdir RPMS
	@[ -d SRPMS ]  || mkdir SRPMS

rpmlint lint: rpm
	rpmlint -vi RPMS/*/*
	rpmlint -vi SRPMS/*

DESTINATION	:= 	people.redhat.com:~williams/public_html/tests

push: rpm
	scp pi_tests-$(VERSION).tar.gz $(DESTINATION)
	scp SRPMS/* $(DESTINATION)

=== debian/changelog ===
rt-tests (0.87-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
   - debian/patches/adding-missing-manpages.patch:
     - Adding missing manpages for signaltest and rt-migrate-test

 -- Andy Whitcroft <apw@canonical.com>  Mon, 06 Jan 2014 13:38:44 +0000

rt-tests (0.87-1) unstable; urgency=low

  * upstream changed path to released archives
  * new upstream release
  * Standards-Version: 3.9.5 (no changes needed)

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Sun, 29 Dec 2013 13:22:45 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Uwe Kleine-König <uwe@kleine-koenig.org>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc powerpcspe ppc64 x32], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

=== debian/rules ===
#!/usr/bin/make -f

export prefix=/usr

ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel powerpc))
export NUMA=1
endif

DH_SEQUENCE = $@
DH = dh $(DH_SEQUENCE) --with dkms

build-arch: build-arch-stamp
build-indep:
build: build-arch build-indep

install: build install-stamp

build-arch-stamp install-stamp: DH_SEQUENCE = ${@:-stamp=}
build-arch-stamp install-stamp:
	$(DH)
	touch $@

binary-arch binary-indep: install
	$(DH)

binary: binary-arch binary-indep

clean:
	$(DH)

.PHONY: build-arch build-indep build clean install binary-indep binary-arch binary

=== debian/watch ===
version=3

http://www.kernel.org/pub/linux/kernel/people/clrkwllms/rt-tests-(.*)\.tar\.gz

## rt-tests 0.89

=== debian/changelog ===
rt-tests (0.89-1ubuntu1) vivid; urgency=low

  * Merge from Debian unstable.  Remaining changes:
   - debian/patches/adding-missing-manpages.patch:
     + Adding missing manpages for signaltest and rt-migrate-test.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 08 Feb 2015 11:54:02 +0100

rt-tests (0.89-1) unstable; urgency=medium

  * new upstream release
  * enable numa for mips{64,n32}{,el} (Closes: #756597)

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Thu, 31 Jul 2014 23:31:39 +0200

rt-tests (0.88-1) unstable; urgency=low

  * new upstream release

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Fri, 28 Mar 2014 21:48:54 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Uwe Kleine-König <uwe@kleine-koenig.org>
 Standards-Version: 3.9.5
-Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel powerpc powerpcspe ppc64 x32], dkms (>= 2.1.0.0)
+Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

## rt-tests 0.93

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,18 @@
-VERSION_STRING = 0.85
-
-sources = cyclictest.c signaltest.c pi_stress.c rt-migrate-test.c	\
-	  ptsematest.c sigwaittest.c svsematest.c pmqtest.c sendme.c 	\
-	  pip_stress.c hackbench.c
+VERSION = 0.93
+
+HAVE_NPTL ?= yes
+
+ifeq ($(HAVE_NPTL),yes)
+sources = cyclictest.c pi_stress.c pip_stress.c pmqtest.c rt-migrate-test.c
+endif
+
+sources += signaltest.c ptsematest.c sigwaittest.c svsematest.c sendme.c \
+	  hackbench.c
 
 TARGETS = $(sources:.c=)
 
-LIBS 	= -lrt -lpthread -lrttest -L.
+LIBS	= -lrt -lpthread
+RTTESTLIB = -lrttest -L.
 EXTRA_LIBS ?= -ldl	# for get_cpu
 DESTDIR	?=
 prefix  ?= /usr/local
@@ -16,13 +22,17 @@
 
 machinetype = $(shell $(CC) -dumpmachine | \
     sed -e 's/-.*//' -e 's/i.86/i386/' -e 's/mips.*/mips/' -e 's/ppc.*/powerpc/')
-ifneq ($(filter x86_64 i386 ia64 mips powerpc,$(machinetype)),)
-NUMA 	:= 1
-endif
 
 CFLAGS ?= -Wall -Wno-nonnull
 CPPFLAGS += -D_GNU_SOURCE -Isrc/include
 LDFLAGS ?=
+
+ifneq ($(filter x86_64 i386 ia64 mips powerpc,$(machinetype)),)
+NUMA 	:= 1
+ifdef HAVE_PARSE_CPUSTRING_ALL
+	CFLAGS += -DHAVE_PARSE_CPUSTRING_ALL
+endif
+endif
 
 PYLIB  := $(shell python -c 'import distutils.sysconfig;  print distutils.sysconfig.get_python_lib()')
 
@@ -50,7 +60,7 @@
 VPATH	+= src/hackbench
 
 %.o: %.c
-	$(CC) -D VERSION_STRING=$(VERSION_STRING) -c $< $(CFLAGS) $(CPPFLAGS)
+	$(CC) -D VERSION=$(VERSION) -c $< $(CFLAGS) $(CPPFLAGS)
 
 # Pattern rule to generate dependency files from .c files
 %.d: %.c
@@ -63,44 +73,44 @@
 -include $(sources:.c=.d)
 
 cyclictest: cyclictest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(NUMA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(NUMA_LIBS)
 
 signaltest: signaltest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
-
-pi_stress: pi_stress.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
+
+pi_stress: pi_stress.o librttest.a
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
 
 hwlatdetect:  src/hwlatdetect/hwlatdetect.py
 	chmod +x src/hwlatdetect/hwlatdetect.py
 	ln -s src/hwlatdetect/hwlatdetect.py hwlatdetect
 
 rt-migrate-test: rt-migrate-test.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)
 
 ptsematest: ptsematest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
 sigwaittest: sigwaittest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
 svsematest: svsematest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
 pmqtest: pmqtest.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
 sendme: sendme.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS) $(EXTRA_LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB) $(EXTRA_LIBS)
 
 pip_stress: pip_stress.o librttest.a
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS) $(RTTESTLIB)
 
 hackbench: hackbench.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^ $(LIBS)
-
-librttest.a: rt-utils.o error.o rt-get_cpu.o
-	$(AR) rcs librttest.a rt-utils.o error.o rt-get_cpu.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< $(LIBS)
+
+librttest.a: rt-utils.o error.o rt-get_cpu.o rt-sched.o
+	$(AR) rcs librttest.a $^
 
 CLEANUP  = $(TARGETS) *.o .depend *.*~ *.orig *.rej rt-tests.spec *.d *.a
 CLEANUP += $(if $(wildcard .git), ChangeLog)
@@ -108,12 +118,14 @@
 .PHONY: clean
 clean:
 	for F in $(CLEANUP); do find -type f -name $$F | xargs rm -f; done
+	rm -f rt-tests-*.tar
 	rm -f hwlatdetect
 	rm -f tags
 
+RPMDIRS = BUILD BUILDROOT RPMS SRPMS SPECS
 .PHONY: distclean
 distclean: clean
-	rm -rf BUILD RPMS SRPMS releases *.tar.gz rt-tests.spec
+	rm -rf $(RPMDIRS) releases *.tar.gz rt-tests.spec tmp
 
 .PHONY: changelog
 changelog:
@@ -143,24 +155,39 @@
 	gzip src/hackbench/hackbench.8 -c >"$(DESTDIR)$(mandir)/man8/hackbench.8.gz"
 
 .PHONY: release
-release: clean changelog
+release: distclean changelog
 	mkdir -p releases
-	rm -rf tmp && mkdir -p tmp/rt-tests
-	cp -r Makefile COPYING ChangeLog src tmp/rt-tests
-	tar -C tmp -czf rt-tests-$(VERSION_STRING).tar.gz rt-tests
+	mkdir -p tmp/rt-tests
+	cp -r Makefile COPYING ChangeLog MAINTAINERS doc README.markdown src tmp/rt-tests
+	rm -f rt-tests-$(VERSION).tar rt-tests-$(VERSION).tar.asc
+	tar -C tmp -cf rt-tests-$(VERSION).tar rt-tests
+	gpg2 --default-key clrkwllms@kernel.org --detach-sign --armor rt-tests-$(VERSION).tar
+	gzip rt-tests-$(VERSION).tar
 	rm -f ChangeLog
-	cp rt-tests-$(VERSION_STRING).tar.gz releases
+	cp rt-tests-$(VERSION).tar.gz rt-tests-$(VERSION).tar.asc releases
+
+.PHONY: tarball
+tarball:
+	git archive --worktree-attributes --prefix=rt-tests-${VERSION}/ -o rt-tests-${VERSION}.tar v${VERSION}
 
 .PHONY: push
 push:	release
-	scripts/do-git-push $(VERSION_STRING)
+	scripts/do-git-push $(VERSION)
 
 .PHONY: pushtest
 pushtest: release
-	scripts/do-git-push --test $(VERSION_STRING)
+	scripts/do-git-push --test $(VERSION)
 
 rt-tests.spec: Makefile rt-tests.spec-in
-	sed s/__VERSION__/$(VERSION_STRING)/ <$@-in >$@
+	sed s/__VERSION__/$(VERSION)/ <$@-in >$@
+ifeq ($(NUMA),1)
+	sed -i -e 's/__MAKE_NUMA__/NUMA=1/' $@
+	sed -i -e 's/__BUILDREQUIRES_NUMA__/numactl-devel/' $@
+else
+	sed -i -e 's/__MAKE_NUMA__//' $@
+	sed -i -e 's/__BUILDREQUIRES_NUMA__//' $@
+endif
+
 
 HERE	:=	$(shell pwd)
 RPMARGS	:=	--define "_topdir $(HERE)" 	\
@@ -192,4 +219,4 @@
 
 .PHONY: tags
 tags:
-	ctags -R --extra=+f --c-kinds=+p *
+	ctags -R --extra=+f --c-kinds=+p --exclude=tmp --exclude=BUILD *

=== debian/changelog ===
rt-tests (0.93-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/patches/adding-missing-manpages.patch:
      + Adding missing manpages for signaltest and rt-migrate-test

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 29 Nov 2015 21:36:51 -0500

rt-tests (0.93-1) unstable; urgency=medium

  * new upstream release
  * fix version reported by rt-migrate-test -h (patch by John Kacur) 

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Mon, 17 Aug 2015 20:41:14 +0200

rt-tests (0.92-1) unstable; urgency=medium

  * new upstream release (Closes: #716237)
  * Standards-Version: 3.9.6 (no changes needed)

 -- Uwe Kleine-König <uwe@kleine-koenig.org>  Fri, 12 Jun 2015 22:35:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Uwe Kleine-König <uwe@kleine-koenig.org>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9), libnuma-dev (>= 2.0.3) [amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc powerpcspe ppc64 x32], dkms (>= 2.1.0.0)
 Vcs-Browser: http://git.pengutronix.de/?p=ukl/rt-tests.git;
 Vcs-Git: git://git.pengutronix.de/git/ukl/rt-tests.git

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 export prefix=/usr
 
-ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel powerpc))
+ifneq (,$(findstring $(DEB_BUILD_ARCH), amd64 i386 ia64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc))
 export NUMA=1
 endif

=== debian/watch ===
version=3

http://www.kernel.org/pub/linux/utils/rt-tests/rt-tests-(.*)\.tar\.xz
